/*	$Id: GenWIDGET.c,v 1.7 91/02/26 21:07:07 jdf Exp $
 *	$CurLog$	(Log at end)
 */
#include <stdio.h>
#include <ctype.h>
#include <sys/types.h>
#include <sys/stat.h>

#include <X11/IntrinsicP.h>
#ifdef MOTIF
# include <Xm/XmP.h>
# ifdef DEC_MOTIF_EXTENSION
// I am not sure this is specific to DEC but this is safer...
#  include <Xm/ExtObjectP.h>
#  include <Xm/VendorEP.h>
# endif
#endif

typedef struct {
  WidgetClass*	wc;
  char*	wc_name;
  char*	header;
  char*	methods;
} widget_class_desc;

#define DEFINE_WIDGET(w,h)	extern WidgetClass w;
#define DEFINE_OBJECT(o,h)

#include "defs/GenWIDGET.def"


#ifdef __STDC__
#define DEFINE_WIDGET(w,h)	{ &w, #w, h },
#define DEFINE_OBJECT(o,h)	{ (WidgetClass *)&o, #o, h },
#else
#define DEFINE_WIDGET(w,h)	{ &w, "w", h },
#define DEFINE_OBJECT(o,h)	{ (WidgetClass *)&o, "o", h },
#endif

widget_class_desc all_widgets[] = {
#include "defs/GenWIDGET.def"
};

#ifdef __STDC__
void*	malloc (int);
void*	realloc (void* , int);
#else
char*	malloc ();
char*	realloc ();
#endif

static int
XtClassIsSubclass (wc1, wc2)
     WidgetClass wc1;
     WidgetClass wc2;
{
	while (wc1) {
		if (wc1 == wc2)
			return 1;
		wc1 = wc1->core_class.superclass;
	}
	return 0;
}

typedef struct _assoc {
  char*	rep;
  char*	c_rep;
} assoc;

assoc*	assoc_table;
int	num_assoc;
int	allocated_assoc;

char*
load_assoc_file (file)
     char* file;
{
  FILE* f;
  char* contents;
  struct stat st;

  if (stat (file, &st) < 0)
    {
      fprintf (stderr, "couldn't access %s\n", file);
      return NULL;
    }
  if ((st.st_mode&S_IFMT) == S_IFDIR)
    {
      fprintf (stderr, "%s is a directory\n", file);
      return NULL;
    }
  if ((st.st_mode&S_IFMT) == S_IFREG)
    {
      contents = malloc (st.st_size + 1);
      if (contents == NULL)
	{
	  fprintf (stderr, "couldn't malloc %d\n", st.st_size);
	  return NULL;
	}

      f = fopen(file, "r");
      if (f == NULL)
	{
	  fprintf (stderr, "unexpected err, couldn't open %s\n", file);
	  return NULL;
	}
      fread (contents, 1, st.st_size, f);
      fclose (f);
      return contents;
    }
  else
    {
      /* try to read from stream ... */
      int size;
      int read_size = 0;
      int len;

      size = BUFSIZ;
      contents = malloc (size);

      while ((len = fread (contents, 1, BUFSIZ, f)) == BUFSIZ)
	{
	  size += BUFSIZ;
	  contents = realloc (contents, size);
	  read_size += BUFSIZ;
	}
      read_size += len;
      return realloc (contents, read_size);
    }
}

void
add_assoc(rtype, ctype)
     char* rtype;
     char* ctype;
{
  if (num_assoc >= allocated_assoc)
    {
      allocated_assoc += 1000;
      if (allocated_assoc == 1000)
	assoc_table = (assoc *)malloc (allocated_assoc * sizeof (assoc));
      else
	assoc_table = (assoc *)realloc (assoc_table, allocated_assoc * sizeof (assoc));
      if (assoc_table == NULL)
	{
	  fprintf(stderr, "couldn't allocated assoc_table");
	  exit (1);
	}
    }
  assoc_table[num_assoc].rep = rtype;
  assoc_table[num_assoc].c_rep = ctype;
  num_assoc++;
}

char*
decode_type (type)
     char** type;
{
  char* str = *type;
  char* ret;

  while (str && isspace (*str))
    str++;

  if (*str == 0)
    {
      *type = NULL;
      return NULL;
    }

  if (*str == '"')
    {
      str++;
      ret = str;
      while (*str && *str != '"')
	str++;
    }
  else
    {
      ret = str;
      while (*str && ! isspace (*str))
	str++;
    }
  *type = (*str == 0 ? str : str + 1);
  *str = 0;
  return ret;
}

int
compare_assoc (a1, a2)
     assoc* a1;
     assoc* a2;
{
  return strcmp (a1->rep, a2->rep);
}

void
add_assoc_file (file)
     char *file;
{
  char* types = load_assoc_file (file);
  char* rep;
  char* c_rep;

  while (types != 0)
    {
      rep = decode_type (&types);
      if (types)
	c_rep = decode_type (&types);
      else
	c_rep = 0;
      if (rep && c_rep)
	add_assoc (rep, c_rep);
    }
  qsort ((char *)assoc_table, num_assoc, sizeof(assoc), compare_assoc);
}

char*
find_type (rep)
     char* rep;
{
  int low, high, old_med, med, ret;

  for (old_med = -1, low = 0, high = num_assoc, med = num_assoc / 2;
       old_med != med;
       med = (low + high )/2)
    {
      ret = strcmp (rep, assoc_table[med].rep);
      if (ret == 0)
	return assoc_table[med].c_rep;
      else if (ret < 0)
	high = med;
      else
	low = med;
      old_med = med;
    }
  return NULL;
}

void
output_type (type, output)
     char* type;
     FILE* output;
{
  char* new_type = find_type (type);

  if (new_type == NULL && type[0] == 'X' && type[1] == 'm')
    new_type = find_type(type+2);

  if (new_type == NULL)
    {
      char t[256];
      int i;

      fprintf(stderr, "type \"%s\" unknown, use what type instead (unsigned char) ?: ",
	      type);
      fflush (stderr);
      fgets (t, 256, stdin);
      for (i = 0; t[i] != 0 && isspace(t[i]); i++);

      if (t[i] == 0)
	fputs("unsigned char", output);
      else
	fputs(&t[i], output);
    }
  else
    fputs(new_type, output);
}

void
translate_resource (res, output)
     XtResource* res;
     FILE* output;
{
  int callback;

  putc('\t', output);

  if (strcmp (res->resource_type, "Callback") == 0)
    {
      fputs ("DEFINE_CALLBACK (", output);
      callback = 1;
    }
  else
    {
      fputs ("DEFINE_GETTER_SETTER (", output);
      callback = 0;
    }
      
  if (islower (res->resource_name[0]))
    putc(toupper (res->resource_name[0]), output);
  else
    putc(res->resource_name[0], output);
  fputs(&res->resource_name[1], output);
  putc(',', output);

  if (! callback)
    {
      output_type (res->resource_type, output);
      putc(',', output);
    }

  putc('"', output);
  fputs(res->resource_name, output);
  putc('"', output);
  fputs(")\n", output);
}

void
edit_class (h_name, class_name)
     char* h_name;
     char* class_name;
{
  char ed_name[100];
  char ed_command[256];

  strcpy(ed_name, class_name);
  strcat(ed_name, ".ed");
  if (access (ed_name, R_OK) == -1)
    return;

  printf("Editing %s\n", h_name);
  sprintf(ed_command, "ed %s <%s", h_name, ed_name);
  system (ed_command);
}

void
add_specific_file (name, suffix, output)
     char* name;
     char* suffix;
     FILE *output;
{
  FILE* input;
  char line[BUFSIZ];

  strcpy (line, "defs/");
  strcat (line, name);
  strcat (line, suffix);
  input = fopen (line, "r");
  if (input == NULL)
    return;
  printf ("Adding specific file %s\n", line);
  while (fgets(line, BUFSIZ, input) != NULL)
    fputs(line, output);
  fclose (input);
}
 
void
translate_class (c, wc_name, header)
     WidgetClass c;
     char* wc_name;
     char* header;
{
  XtResource* xtr = c->core_class.resources;
  Cardinal nxtr = c->core_class.num_resources;
  int i;
  char* name = c->core_class.class_name;
  char* super_name =  c->core_class.superclass ?
    c->core_class.superclass->core_class.class_name : 0;
  char fname[100];
  FILE* output;
  FILE* input;

  sprintf(fname, "Gen/%s.h", name);

  output = fopen (fname, "w");

  if (output == NULL)
    {
      fprintf(stderr, "couldn't open %s\n", name);
      return;
    }
  else
    printf("Generating \"%s\"\n", fname);

  fputs("// This code is automatically generated in -*- C++ -*-\n", output);
  fprintf (output, "#ifndef _CC_%s_h\n#define _CC_%s_h\n", name, name);

  if (super_name)
    fprintf (output, "#ifndef _CC_%s_h\n#include \"WWL/%s.h\"\n#endif\n",
	     super_name, super_name);
  else
    fputs ("#ifndef _CC_wwl_h\n#include \"WWL/wwl.h\"\n#endif\n", output);

  fprintf (output, "#include <%s>\n", header);

  if (super_name)
    {
      fprintf (output, "class W%s : public W%s {\npublic :\n",
	       name, super_name);
      fprintf (output, "\t\tDEFINE_INIT (W%s, %s)\n",
	       c->core_class.class_name, wc_name);
      if ((strcmp(wc_name + strlen (wc_name) - 15,
		  "hellWidgetClass") == 0) ||
	  (strcmp(wc_name,"compositeWidgetClass") == 0) ||
	  (strcmp(wc_name,"widgetClass") == 0) ||
	  (strcmp(wc_name,"windowObjClass") == 0) ||
	  (strcmp(wc_name,"rectObjClass") == 0)) {
	      fprintf (output, "\t\tDEFINE_POPUP_INIT (W%s, %s)\n",
		       c->core_class.class_name, wc_name);
      }
    }
  else
    fprintf (output,
	     "class W%s {\nprotected :\n\tWidget\twidget;\npublic :\n",
	     name);

  add_specific_file (name, ".def",  output);

  for (i = 0; i < nxtr; i++)
    translate_resource (&xtr[i], output);

  fputs("};\n", output);
  fprintf(output, "#define	NULLW%s		W%s((Widget)0)\n", name, name);

  if (XtClassIsSubclass (c, constraintWidgetClass))
    {
      ConstraintWidgetClass cwc = (ConstraintWidgetClass)c;

      XtResource* xtr = cwc->constraint_class.resources;
      Cardinal nxtr = cwc->constraint_class.num_resources;

      if (c == constraintWidgetClass)
	fprintf (output,
		 "class C%s {\nprotected :\n\tWidget\twidget;\npublic :\n",
		 name);
      else
	{
	  fprintf (output, "class C%s : public C%s {\npublic :\n",
		   name, super_name);
	  fprintf (output, "\t\tDEFINE_CINIT(C%s, %s)\n",
		   c->core_class.class_name, wc_name);
	}

      for (i = 0; i < nxtr; i++)
	translate_resource (&xtr[i], output);
      
      add_specific_file (name, ".cdef", output);
      fputs("};\n", output);
    }

  add_specific_file (name, ".ext", output);

  fputs ("#endif\n", output);
  fclose (output);
}

int
main (argc, argv)
     int argc;
     char* argv[];
{
  int i;

  add_assoc_file ("defs/GenWIDGET.typ");

  mkdir ("Gen", 0777);
  for (i = 0; i < XtNumber (all_widgets); i++)
    translate_class (*all_widgets[i].wc,
		     all_widgets[i].wc_name,
		     all_widgets[i].header);

  exit (0);
}
/*	$Log:	GenWIDGET.c,v $
 *Revision 1.7  91/02/26  21:07:07  jdf
 *Forgotten to handle windowObjectClass to generate POPUP_INIT, useful
 *only for X11R3.
 *
 *Revision 1.6  91/02/25  15:21:46  jdf
 *Handling of Motif resources starting with Xm
 *Shell widgets handleld specially.
 *DEC widgets supported.
 *
 *Revision 1.5  90/11/08  11:50:06  jdf
 *Fixed a call to fread
 *
 *Revision 1.4  90/08/16  18:44:40  jdf
 *Changed GenWIDGET.ass in GenWIDGET.typ
 *
 *Revision 1.3  90/08/13  19:29:27  mbl
 *generate .def before resource list
 *
 *Revision 1.2  90/08/09  17:55:43  jdf
 *changed C++ comments into C comments.
 *
 * Revision 1.1  90/08/09  17:21:44  jdf
 * Initial revision
 */
