#ifndef _wwl_h_
#define _wwl_h_

#include <X11/Intrinsic.h>
#if MOTIF
#include <Xm/Xm.h>
#include "WWL/xmstring.h"
#endif
#include "WWL/wcallback.h"
#include "WWL/wargs.h"

#if defined(__GNUG__) || defined(SHARP_CATENATE)
#define _concat(x,y)	x##y
#define _stringify(x)	#x
#else
#define _concat(x,y)	x/**/y
#define _stringify(x)	"x"
#endif

class WComposite;
#ifndef _XtintrinsicP_h
typedef void	(* XtProc)();
#endif

#define	DEFINE_GETTER(resource,type,rname)  		  \
inline	type	resource () const			  \
		{ Arg a; type __value;			  \
		  a.name = rname; a.value = (XtArgVal)&__value; \
		  _Get(a); return __value; }

#define	DEFINE_SETTER(resource,type,rname)  		  \
inline	void	resource (type val) const			  \
		{ Arg a; a.name = rname; a.value = (XtArgVal)val; _Set(a); }

#define	DEFINE_ARG(resource,type,rname)			 \
inline	WArgList& resource (type val, WArgList& _w) const	 \
	        { return _w.Add (rname, val); }

#define	DEFINE_GETTER_SETTER(resource,type,rname)  		  \
	DEFINE_GETTER(resource,type,rname)  		  	  \
	DEFINE_SETTER(resource,type,rname)			  \
	DEFINE_ARG(resource, type,rname)

#define	DEFINE_INIT(class_name, class)				  \
inline	class_name (Widget w) : (w) {}				  \
inline	class_name (const WComposite& father,			  \
		    WidgetClass c = (WidgetClass)class,		  \
		    const char *name = _stringify(class_name),	  \
		    ArgList args = NULL, Cardinal card = 0)	  \
		: (father, c, name, args, card) {}	  	  \
inline	class_name (const WComposite& father,		  	  \
		    const char *name,				  \
		    ArgList args = NULL, Cardinal card = 0)	  \
		:  (father, (WidgetClass)class, name, args, card) {} \
inline	class_name (const WComposite& father,		  	  \
		    const char *name,				  \
		    WArgList args)				  \
		:  (father, (WidgetClass)class, name, args.Args(), args.NumArgs()) {} \
inline	class_name& operator = (const class_name& w)	{ widget = w.widget; return *this; }


#define DEFINE_POPUP_INIT(class_name, class)			  \
inline	class_name (const WComposite& father,			  \
		    Boolean popup,				  \
		    WidgetClass c = (WidgetClass)class,		  \
		    const char *name = _stringify(class_name),	  \
		    ArgList args = NULL, Cardinal card = 0)	  \
		: (father, popup, c, name, args, card) {}  	  \
inline	class_name (const WComposite& father,		  	  \
		    Boolean popup,				  \
		    const char *name,				  \
		    ArgList args = NULL, Cardinal card = 0)	  \
		:  (father, popup, (WidgetClass)class, name, args, card) {} \
inline	class_name (const WComposite& father,		  	  \
		    Boolean popup,				  \
		    const char *name,				  \
		    WArgList args)				  \
		:  (father, popup, (WidgetClass)class, name, args.Args(), args.NumArgs()) {} \
inline	void Popup (XtGrabKind grab = XtGrabNone) 		  \
		{ XtPopup(widget,grab); }	       	  	  \
inline	void Popdown () { XtPopdown(widget); }

#define	DEFINE_CINIT(class_name, class)				  \
inline	class_name (Widget w) : (w) {}				  \
inline	class_name (WObject& o) : (o) {}


#define DEFINE_CALLBACK(cb_name, cb_res)			      \
inline	void	_concat(Add,cb_name) (XtCallbackProc proc, caddr_t closure = 0) const \
		{ XtAddCallback(widget, cb_res, proc, closure); }     \
inline	void	_concat(Remove,cb_name) (XtCallbackProc proc, caddr_t closure = 0) const \
		{ XtRemoveCallback(widget, cb_res, proc, closure); }     \
inline	void	_concat(Call,cb_name) (caddr_t call_data) const \
		{ XtCallCallbacks(widget, cb_res, call_data); }     \
inline	void	_concat(RemoveAll,cb_name) () const \
		{ XtRemoveAllCallbacks(widget, cb_res); } \
	DEFINE_GETTER_SETTER (cb_name, XtCallbackList, cb_res) \
inline	WCallback*	_concat(Set,cb_name) (WWL* obj, WWL_FUN fun) const	{ return SetCallback (cb_res, obj, fun); }

#define NULLWidget	((Widget)0)
#endif
