#ifdef REV_INFO
#ifndef lint
static char SCCSID[] = "OSF/Motif: @(#)Intrinsic.h	1.2 89/08/16";
#endif /* lint */
#endif /* REV_INFO */

#ifndef _XtIntrinsic_h
#define _XtIntrinsic_h
#include	<sys/types.h>
#include	<X11/Xlib.h>
#include	<X11/Xutil.h>
#include	<X11/Xresource.h>
#include	<X11/Xos.h>

#ifndef NULL
#define NULL 0
#endif

#define externalref extern
#define externaldef(psect)

#ifndef FALSE
#define FALSE 0
#define TRUE 1
#endif

#define XtNumber(arr)		((Cardinal) (sizeof(arr) / sizeof(arr[0])))

#ifdef __cplusplus
#define String char*
#else
typedef char *String;
#endif
typedef struct _WidgetRec *Widget;
typedef Widget *WidgetList;
typedef struct _WidgetClassRec *WidgetClass;
typedef struct _CompositeRec *CompositeWidget;
typedef struct _XtActionsRec *XtActionList;
typedef struct _XtEventRec *XtEventTable;
typedef struct _XtBoundAccActionRec *XtBoundAccActions;
typedef unsigned int   Cardinal;
typedef unsigned short  ShortCard;
typedef char	Boolean;
typedef unsigned long	*Opaque;
typedef struct _XtAppStruct *XtAppContext;
typedef unsigned long   XtValueMask;
typedef unsigned long   XtIntervalId;
typedef unsigned long   XtInputId;
typedef unsigned long	XtWorkProcId;
typedef unsigned int    XtGeometryMask;
typedef unsigned long   XtGCMask;   /* Mask of values that are used by widget*/
typedef unsigned long   Pixel;	    /* Index into colormap	        */
typedef int		Position;   
typedef Cardinal	Dimension;  /* Size in pixels		        */

/****************************************************************
 *
 * System Dependent Definitions
 *
 *
 * XtArgVal ought to be a union of caddr_t, char *, long, int *, and proc *
 * but casting to union types is not really supported.
 *
 * So the typedef for XtArgVal should be chosen such that
 *
 *      sizeof (XtArgVal) >=	sizeof(caddr_t)
 *				sizeof(char *)
 *				sizeof(long)
 *				sizeof(int *)
 *				sizeof(proc *)
 *
 * ArgLists rely heavily on the above typedef.
 *
 ****************************************************************/
typedef long XtArgVal;

#include <X11/Core.h>
#include <X11/Composite.h>
#include <X11/Constraint.h>

#ifndef NOT_MOTIF
/*
 * Include the gadget headers so that clients don't have to reference
 * IntrinsicI.h
 */
#include <X11/Object.h>
#include <X11/RectObj.h>
#include <X11/WindowObj.h>
#include <X11/CompObj.h>

#define XtIsWindowObject(widget)    XtIsSubclass(widget, (WidgetClass) windowObjClass)
#define XtIsCompositeObject(widget) XtIsSubclass(widget, (WidgetClass) compositeObjectClass)
#define XtIsRectObject(widget)      XtIsSubclass(widget, (WidgetClass) rectObjClass)
#endif /* NOT_MOTIF */


/***************************************************************
 *
 * Resource Conversions
 *
 ****************************************************************/
#ifdef __cplusplus
extern "C" {
#endif

#if defined(__STDC__) || defined(__cplusplus)
#define _PROTO(a)	a
#else
#define	_PROTO(a)	()
#endif

extern void _XtConvertInitialize();

extern void XtStringConversionWarning _PROTO((const String,String));
    /* String   from;       */  /* String attempted to convert.     */
    /* String   toType;     */  /* Type attempted to convert it to. */

typedef void (*XtConverter) _PROTO((XrmValue*,Cardinal*,XrmValue*,XrmValue*));
    /* XrmValue		    *args;	    */
    /* Cardinal		    *num_args;       */
    /* XrmValue		    *from;	    */
    /* Xrmvalue		    *to;	    */

#ifdef __cplusplus
 }
#endif

typedef enum {
/* address mode     		parameter representation    	   */
/* ------------     		------------------------   	   */
    XtAddress,      		/* address		    	   */
    XtBaseOffset,	   	/* offset		    	   */
#ifndef NOT_MOTIF
    XtWindowObjBaseOffset,   	/* offset in nearest window object */
#endif /* NOT_MOTIF */
    XtImmediate,    		/* constant		    	   */
    XtResourceString,		/* resource name string     	   */
    XtResourceQuark		/* resource name quark      	   */
} XtAddressMode;

typedef struct {
    XtAddressMode   address_mode;
    caddr_t	    address_id;
    Cardinal	    size;
} XtConvertArgRec, *XtConvertArgList;

extern XtConvertArgRec colorConvertArgs[];
extern XtConvertArgRec screenConvertArg[];

#ifdef __cplusplus
extern "C" {
#endif

extern void XtAppAddConverter _PROTO((XtAppContext,String,String,XtConverter,
				      XtConvertArgList,Cardinal));
    /* XtAppContext	    app;	*/
    /* String		    from_type;      */
    /* String		    to_type;	    */
    /* XtConverter      converter;      */
    /* XtConvertArgList     convert_args;   */
    /* Cardinal		    num_args;   */

extern void XtAddConverter _PROTO((String,String,XtConverter,XtConvertArgList,Cardinal));
    /* String		    from_type;      */
    /* String		    to_type;	    */
    /* XtConverter      converter;      */
    /* XtConvertArgList     convert_args;   */
    /* Cardinal		    num_args;   */

extern void XtConvert _PROTO((Widget,String,XrmValue*,String,XrmValue*));
    /* Widget		    widget;	    */
    /* String		    from_type;	    */
    /* XrmValue		    *from;	    */
    /* String		    to_type;	    */
    /* XrmValue		    *to;	    */  /* RETURN */

extern void XtDirectConvert _PROTO((XtConverter,XrmValuePtr,Cardinal,XrmValuePtr,XrmValue*));
    /* XtConverter	    converter;      */
    /* XrmValuePtr	    args;	    */
    /* Cardinal		    num_args;       */
    /* XrmValuePtr	    from;	    */
    /* XrmValue		    *to;	    */  /* RETURN */

#ifdef __cplusplus
 }
#endif

/****************************************************************
 *
 * Translation Management
 *
 ****************************************************************/

typedef struct _TranslationData *XtTranslations;
typedef struct _TranslationData *XtAccelerators;
typedef unsigned int Modifiers;

typedef void (*XtActionProc) _PROTO((Widget,XEvent*,String*,Cardinal*));
    /* Widget widget; */
    /* XEvent *event; */
    /* String *params; */
    /* Cardinal *num_params; */

typedef XtActionProc* XtBoundActions;

typedef struct _XtActionsRec{
    char    *string;
    XtActionProc proc;
} XtActionsRec;

#ifdef __cplusplus
extern "C" {
#endif

extern XtTranslations XtParseTranslationTable _PROTO((String)); /* source */
    /* String *source; */

extern XtAccelerators XtParseAcceleratorTable _PROTO((String));
   /* String *source */

extern void XtOverrideTranslations _PROTO((Widget,XtTranslations)); /* widget, new */
    /* Widget widget; */
    /* XtTranslations new; */

extern void XtAugmentTranslations _PROTO((Widget,XtTranslations)); /* widget, new */
    /* Widget widget; */
    /* XtTranslations new; */

extern void XtInstallAccelerators _PROTO((Widget,Widget));
   /* Widget destination,source */

extern void XtInstallAllAccelerators _PROTO((Widget,Widget));
  /* Widget destination,source */

extern void XtUninstallTranslations _PROTO((Widget));
   /* Widget widget */

extern void XtAppAddActions _PROTO((XtAppContext,XtActionList,Cardinal));
   /* XtAppContext app */
   /* XtActionList action */
   /* Cardinal num_actions */

extern void XtAddActions _PROTO((XtActionList,Cardinal)); /* action, num_actions */
   /* XtActionList action */
   /* Cardinal num_actions */

#ifdef __cplusplus
 }
#endif

/***************************************************************
 *
 * Keycode and Keysym procedures for translation management
 *
 ****************************************************************/

typedef void (*XtKeyProc) _PROTO((Display*,KeyCode*,Modifiers*,Modifiers*,KeySym*));
/*
    Display *dpy;
    KeyCode *keycode;
    Modifiers *modifiers;
    Modifiers *modifiers_return;
    KeySym *keysym_return;

*/

#ifdef __cplusplus
extern "C" {
#endif

extern void XtTranslateKeycode _PROTO((Display*,KeyCode,Modifiers,Modifiers*,KeySym*));
/*
    Display *dpy;
    KeyCode keycode;
    Modifiers modifiers;
    Modifiers *modifiers_return;
    KeySym *keysym_return;
*/

extern void XtTranslateKey _PROTO((Display*,KeyCode,Modifiers,Modifiers*,KeySym*));
/*
    Display *dpy;
    KeyCode *keycode;
    Modifiers *modifiers;
    Modifiers *modifiers_return;
    KeySym *keysym_return;

*/

extern void XtSetKeyTranslator _PROTO((Display*,XtKeyProc));
/*  Display *dpy;
    XtKeyProc proc;
*/

typedef void (*XtCaseProc) _PROTO((KeySym*,KeySym*,KeySym*));
/*
    KeySym *keysym;
    KeySym *lower_return;
    KeySym *upper_return;
*/

extern void XtRegisterCaseConverter _PROTO((Display*,XtCaseProc,KeySym,KeySym));
/*  Display *dpy;
    XtCaseProc proc;
    KeySym start;
    KeySym stop;
*/

extern void XtConvertCase _PROTO((Display*,KeySym,KeySym*,KeySym*));
/*  Display *dpy;
    KeySym keysym;
    KeySym *lower_return;
    KeySym *upper_return;
*/

#ifdef __cplusplus
 }
#endif

/****************************************************************
 *
 * Event Management
 *
 ****************************************************************/

typedef void (*XtEventHandler) _PROTO((Widget,caddr_t,XEvent*)); /* widget, closure, event */
    /* Widget  widget   */
    /* caddr_t closure  */
    /* XEvent  *event;  */

typedef void (*XtAsyncHandler) _PROTO((Opaque)); /* closure */
    /* Opaque closure; */

typedef unsigned long EventMask;
#define XtAllEvents ((EventMask) -1L)

#ifdef __cplusplus
extern "C" {
#endif

extern void XtAddEventHandler _PROTO((Widget,EventMask,Boolean,XtEventHandler,caddr_t));
    /* Widget		widget      */
    /* EventMask        eventMask;  */
    /* Boolean          nonmaskable; */
    /* XtEventHandler   proc;       */
    /* caddr_t		closure ;   */

extern void XtRemoveEventHandler _PROTO((Widget,EventMask,Boolean,XtEventHandler,caddr_t));
    /* Widget		widget      */
    /* EventMask        eventMask;  */
    /* Boolean          nonmaskable;*/
    /* XtEventHandler   proc;       */
    /* caddr_t		closure ;   */

extern void XtAddRawEventHandler _PROTO((Widget,EventMask,Boolean,XtEventHandler,caddr_t));
    /* Widget		widget      */
    /* EventMask        eventMask;  */
    /* Boolean          nonmaskable; */
    /* XtEventHandler   proc;       */
    /* caddr_t		closure ;   */

extern void XtRemoveRawEventHandler _PROTO((Widget,EventMask,Boolean,XtEventHandler,caddr_t)); /* widget, eventMask, nonmaskable, proc, closure */
    /* Widget		widget      */
    /* EventMask        eventMask;  */
    /* Boolean          nonmaskable;*/
    /* XtEventHandler   proc;       */
    /* caddr_t		closure ;   */

extern EventMask XtBuildEventMask _PROTO((Widget)); /* widget */
    /* Widget widget; */

extern void XtAddGrab _PROTO((Widget,Boolean,Boolean));
    /* Widget   widget;		    */
    /* Boolean  exclusive;	    */
    /* Boolean  spring_loaded;      */

extern void XtRemoveGrab _PROTO((Widget));
    /* Widget   widget;		    */

extern Boolean XtDispatchEvent _PROTO((XEvent*)); /* event */
    /* XEvent	*event; */

typedef unsigned long	XtInputMask;

extern void XtProcessEvent _PROTO((XtInputMask));
    /* XtInputMask mask; */

extern void XtAppProcessEvent _PROTO((XtAppContext,XtInputMask));
    /* XtAppContext app; */
    /* XtInputMask mask; */

extern void XtMainLoop();

extern void XtAppMainLoop _PROTO((XtAppContext));
    /* XtAppContext app; */

extern void XtAddExposureToRegion _PROTO((XEvent*,Region));
    /* XEvent   *event;	*/
    /* Region   region;	*/

extern void XtSetAsyncEventHandler _PROTO((XtAsyncHandler,Opaque));
    /* XtAsyncHandler handler; */
    /* Opaque	closure; */

extern void XtMakeToolkitAsync();

extern void XtSetKeyboardFocus _PROTO((Widget,Widget));
    /* Widget subtree, descendent; */

#ifdef __cplusplus
 }
#endif


/****************************************************************
 *
 * Event Gathering Routines
 *
 ****************************************************************/


#define XtInputNoneMask		0L
#define XtInputReadMask		(1L<<0)
#define XtInputWriteMask	(1L<<1)
#define XtInputExceptMask	(1L<<2)

typedef void (*XtTimerCallbackProc) _PROTO((caddr_t,XtIntervalId*));
    /* caddr_t closure         */
    /* XtIntervalId   *id      */

#ifdef __cplusplus
extern "C" {
#endif

extern XtIntervalId XtAddTimeOut _PROTO((unsigned long,XtTimerCallbackProc,caddr_t));
    /* unsigned long interval */
    /* XtTimerCallbackProc  proc  */
    /* caddr_t   closure      */

extern XtIntervalId XtAppAddTimeOut _PROTO((XtAppContext, unsigned long,XtTimerCallbackProc,caddr_t));
    /* XtAppContext app */
    /* unsigned long interval */
    /* XtTimerCallbackProc  proc  */
    /* caddr_t   closure       */

extern void XtRemoveTimeOut _PROTO((XtIntervalId));
    /* XtIntervalId timer;      */

typedef void (* XtInputCallbackProc)_PROTO((caddr_t,int*,XtInputId*));
    /* caddr_t closure;          */
    /* int    *source;           */
    /* XtInputId  *id;           */

extern XtInputId XtAddInput _PROTO((int,caddr_t,XtInputCallbackProc,caddr_t)); /* source, condition, proc, closure */
    /* int source;		*/
    /* Opaque condition;        */
    /* XtInputCallbackProc proc;*/
    /* caddr_t closure;         */

extern XtInputId XtAppAddInput _PROTO((XtAppContext,int,caddr_t,XtInputCallbackProc,caddr_t)); /* source, condition, proc, closure */
    /*  XtAppContext app; */
    /* int source;		*/
    /* Opaque condition;        */
    /* XtInputCallbackProc proc;*/
    /* caddr_t closure;         */

extern void XtRemoveInput _PROTO((XtInputId)); /* id */
    /* XtInputid id;		*/

extern void XtNextEvent _PROTO((XEvent*)); /* event */
    /* XEvent *event;		*/

extern void XtAppNextEvent _PROTO((XtAppContext,XEvent*));
    /* XtAppContext appContext	*/
    /* XEvent *event;		*/

extern Boolean XtPeekEvent _PROTO((XEvent*)); /* event */
    /* XEvent *event;		*/

extern Boolean XtAppPeekEvent _PROTO((XtAppContext,XEvent*));
    /* XtAppContext appContext	*/
    /* XEvent *event;		*/


#define XtIMXEvent		1
#define XtIMTimer		2
#define XtIMAlternateInput	4
#define XtIMAll (XtIMXEvent | XtIMTimer | XtIMAlternateInput)

extern XtInputMask XtPending ();

extern XtInputMask XtAppPending _PROTO((XtAppContext));
    /* XtAppContext appContext	*/

/****************************************************************
 *
 * Random utility routines
 *
 ****************************************************************/

extern Boolean XtIsSubclass _PROTO((Widget,WidgetClass));
    /* Widget       widget;	    */
    /* WidgetClass  widgetClass;    */



#define XtIsComposite(widget)       XtIsSubclass(widget, (WidgetClass) compositeWidgetClass)
#define XtIsConstraint(widget)      XtIsSubclass(widget, (WidgetClass) constraintWidgetClass)
#define XtIsShell(widget)	    XtIsSubclass(widget, (WidgetClass) shellWidgetClass)


extern void XtRealizeWidget _PROTO((Widget));
    /* Widget    widget      */

void XtUnrealizeWidget _PROTO((Widget)); /* widget */
    /* Widget		widget; */

extern void XtDestroyWidget _PROTO((Widget));
    /* Widget widget */

extern void XtSetSensitive _PROTO((Widget,Boolean));
    /* Widget    widget;    */
    /* Boolean   sensitive; */

extern void XtSetMappedWhenManaged _PROTO((Widget,Boolean));
    /* Widget    widget;    */
    /* Boolean   mappedWhenManaged; */

extern Widget XtNameToWidget _PROTO((Widget,String)); /* root, name */
    /* Widget root; */
    /* String name; */

extern Widget XtWindowToWidget _PROTO((Display*,Window)); /* window */
    /* Display *display; */
    /* Window window; */

#ifdef __cplusplus
 }
#endif


/***************************************************************
 *
 * Arg lists
 *
 ****************************************************************/

typedef struct {
    String	name;
    XtArgVal	value;
} Arg, *ArgList;

#define XtSetArg(arg, n, d) \
    ( (arg).name = (n), (arg).value = (XtArgVal)(d) )

#ifdef __cplusplus
extern "C" {
#endif

extern ArgList XtMergeArgLists _PROTO((ArgList args1, Cardinal num_args1,
				       ArgList args2, Cardinal num_args2));

/*************************************************************
 *
 * Information routines
 *
 ************************************************************/

#ifndef _XtIntrinsicP_h

/* We're not included from the private file, so define these */


extern Display *XtDisplay _PROTO((Widget));
    /*	Widget widget;		*/

extern Screen *XtScreen _PROTO((Widget));
    /*	Widget widget;		*/

extern Window XtWindow _PROTO((Widget));
    /*	Widget widget;		*/

extern WidgetClass XtSuperclass _PROTO((Widget));
    /*	Widget widget;		*/

extern WidgetClass XtClass _PROTO((Widget));
    /*	Widget widget;		*/

extern Boolean XtIsManaged _PROTO((Widget));
    /*	Widget widget;		*/

extern Boolean XtIsRealized _PROTO((Widget));
    /* Widget    widget; */

extern Boolean XtIsSensitive _PROTO((Widget));
    /* Widget	widget; */

extern Widget XtParent _PROTO((Widget));
    /* Widget	widget; */

#endif /* _XtIntrinsicP_h */

#ifdef __cplusplus
 }
#endif

#define XtMapWidget(widget)	XMapWindow(XtDisplay(widget), XtWindow(widget))
#define XtUnmapWidget(widget)	\
		XUnmapWindow(XtDisplay(widget), XtWindow(widget))

typedef struct _XtCallbackRec*    XtCallbackList;

typedef void (*XtCallbackProc) _PROTO((Widget,caddr_t,caddr_t));
    /* Widget widget; */
    /* caddr_t closure;  data the application registered */
    /* caddr_t callData; widget instance specific data passed to application*/

typedef struct _XtCallbackRec {
    XtCallbackProc  callback;
    caddr_t         closure;
} XtCallbackRec;

#ifdef __cplusplus
extern "C" {
#endif


extern void XtAddCallback _PROTO((Widget,const String,XtCallbackProc,caddr_t));
    /* Widget           widget;         */
    /* String           callback_name;  */
    /* XtCallbackProc   callback;       */
    /* caddr_t          closure;        */

extern void XtRemoveCallback _PROTO((Widget,const String,XtCallbackProc,caddr_t));
    /* Widget           widget;         */
    /* String           callback_name;  */
    /* XtCallbackProc   callback;       */
    /* caddr_t          closure;        */

extern void XtAddCallbacks _PROTO((Widget,const String,XtCallbackList));
    /* Widget           widget;         */
    /* String           callback_name;  */
    /* XtCallbackList   callbacks;      */

extern void XtRemoveCallbacks _PROTO((Widget,const String,XtCallbackList));
    /* Widget           widget;         */
    /* String           callback_name;  */
    /* XtCallbackList   callbacks;      */

extern void XtRemoveAllCallbacks _PROTO((Widget,const String));
    /* Widget           widget;         */
    /* String           callback_name;  */


extern void XtCallCallbacks _PROTO((Widget,const String,caddr_t));
    /* Widget           widget;         */
    /* String           callback_name;   */
    /* caddr_t          callData;       */

#ifdef __cplusplus
 }
#endif


/* These utilities are here on Leo's request. We should think about them */
/* and decide if they really belong in the intrinsics, or a level above */

typedef enum {
        XtCallbackNoList,
        XtCallbackHasNone,
        XtCallbackHasSome
} XtCallbackStatus;


#ifdef __cplusplus
extern "C" {
#endif

extern XtCallbackStatus XtHasCallbacks _PROTO((Widget,const String));
    /* Widget           widget; */
    /* String           callback_name; */



/****************************************************************
 *
 * Geometry Management
 *
 ****************************************************************/


/* Additions to Xlib geometry requests: ask what would happen, don't do it */
#define XtCWQueryOnly   (1 << 7)

/* Additions to Xlib stack modes: don't change stack order */
#define XtSMDontChange  5


typedef struct {
    XtGeometryMask request_mode;
    Position x, y;
    Dimension width, height, border_width;
    Widget sibling;
    int stack_mode;    /* Above, Below, TopIf, BottomIf, Opposite, DontChange */
} XtWidgetGeometry;

typedef enum  {
    XtGeometryYes,        /* Request accepted. */
    XtGeometryNo,         /* Request denied. */
    XtGeometryAlmost,     /* Request denied, but willing to take replyBox. */
    XtGeometryDone        /* Request accepted and done. */
} XtGeometryResult;

extern XtGeometryResult XtMakeGeometryRequest _PROTO((Widget,XtWidgetGeometry*,XtWidgetGeometry*));
    /*  widget, request, reply		*/
    /* Widget   widget;			*/
    /* XtWidgetGeometry *request;	*/
    /* XtWidgetGeometry *reply;		*//* RETURN */

extern XtGeometryResult XtMakeResizeRequest _PROTO((Widget,Dimension,Dimension,Dimension*,Dimension*));
    /* Widget    widget;        */
    /* Dimension width, height; */
    /* Dimension *replyWidth, *replyHeight; */

extern void XtTransformCoords _PROTO((register Widget,Position,Position,register Position *,register Position *));
    /* register Widget w;       */
    /* Position x, y;           */
    /* register Position *rootx, *rooty; */

extern XtGeometryResult XtQueryGeometry _PROTO((Widget,XtWidgetGeometry *,XtWidgetGeometry *));
    /* Widget   widget;                 */
    /* XtWidgetGeometry *intended;      */
    /* XtWidgetGeometry *reply_return;  */


/* Class record constants */

extern Widget XtCreatePopupShell _PROTO((const String,WidgetClass,Widget,ArgList,Cardinal));

    /* String       name;           */
    /* WidgetClass  widgetClass;    */
    /* Widget       parent;         */
    /* ArgList      args;           */
    /* Cardinal     num_args;       */

typedef enum {XtGrabNone, XtGrabNonexclusive, XtGrabExclusive} XtGrabKind;


extern void XtPopup _PROTO((Widget,XtGrabKind));
    /* Widget       widget;         */
    /* XtGrabKind   grab_kind;      */

extern void XtCallbackNone _PROTO((Widget,caddr_t,caddr_t));
    /* Widget       widget;         */
    /* caddr_t      closure;        */
    /* caddr_t      call_data;      */

extern void XtCallbackNonexclusive _PROTO((Widget,caddr_t,caddr_t));
    /* Widget       widget;         */
    /* caddr_t      closure;        */
    /* caddr_t      call_data;      */

extern void XtCallbackExclusive _PROTO((Widget,caddr_t,caddr_t));
    /* Widget       widget;         */
    /* caddr_t      closure;        */
    /* caddr_t      call_data;      */

extern void XtPopdown _PROTO((Widget));
    /* Widget       widget;         */

typedef struct {
    Widget  shell_widget;
    Widget  enable_widget;
} XtPopdownIDRec, *XtPopdownID;

extern void XtCallbackPopdown _PROTO((Widget,caddr_t,caddr_t));
    /* Widget       widget;         */
    /* caddr_t      closure;        */
    /* caddr_t      call_data;      */


extern Widget XtCreateWidget _PROTO((const String,WidgetClass,Widget,ArgList,Cardinal));
    /* String       name;           */
    /* WidgetClass  widget_class;    */
    /* Widget       parent;         */
    /* ArgList      args;           */
    /* Cardinal     num_args;       */

extern Widget XtCreateManagedWidget _PROTO((const String,WidgetClass,Widget,ArgList,Cardinal));
    /* String       name;           */
    /* WidgetClass  widget_class;    */
    /* Widget       parent;         */
    /* ArgList      args;           */
    /* Cardinal     num_args;       */

extern Widget XtCreateApplicationShell _PROTO((const String,WidgetClass,ArgList,Cardinal));
    /* String       name;	    */
    /* WidgetClass  widget_class;   */
    /* ArgList      args;           */
    /* Cardinal     num_args;       */

extern Widget XtAppCreateShell _PROTO((const String,const String,WidgetClass,Display*,ArgList,Cardinal));
    /* String       name, class;    */
    /* WidgetClass  widget_class;   */
    /* Display      *display        */
    /* ArgList      args;           */
    /* Cardinal     num_args;       */


/****************************************************************
 *
 * Toolkit initialization
 *
 ****************************************************************/

extern void XtToolkitInitialize();

extern void XtDisplayInitialize _PROTO((XtAppContext,Display*,const String,const String,XrmOptionDescRec *,Cardinal,Cardinal*,char *argv[]));
    /* XtAppContext	    appContext */
    /* Display              *d */
    /* String               name, class; */
    /* XrmOptionsDescRec    options;    */
    /* Cardinal             num_options;  */
    /* Cardinal             *argc; */ /* returns count of args not processed */
    /* char                 **argv;     */

extern Widget XtInitialize _PROTO((const String,
                const String,
                XrmOptionDescRec *,
                Cardinal,
                Cardinal*,char *argv[]));

    /* String               name;       */
    /* String               class;      */
    /* XrmOptionsDescRec    options;    */
    /* Cardinal             num_options;  */
    /* Cardinal             *argc; */ /* returns count of args not processed */
    /* char                 **argv;     */

extern Display *XtOpenDisplay _PROTO((XtAppContext,const String,const String,const String,XrmOptionDescRec*,Cardinal,Cardinal*,const char *argv[]));
   /*   XtAppContext	    appContext */
   /*   String displayName, applName, className;        */
   /*   XrmOptionDescRec *urlist;       */
   /*   Cardinal num_urs;       */
   /*   Cardinal *argc; */
   /*   char *argv[];   */

extern XtAppContext XtCreateApplicationContext();

extern void XtDestroyApplicationContext _PROTO((XtAppContext));
    /* XtAppContext appContext	*/

extern XtAppContext XtWidgetToApplicationContext _PROTO((Widget));
    /* Widget	widget */

extern XrmDatabase XtDatabase _PROTO((Display*));
    /*  Display *dpy; */

extern void XtCloseDisplay _PROTO((Display*));           /* display */
    /* Display *display;        */

#ifdef __cplusplus
 }
#endif


typedef struct {
    XrmQuark	xrm_name;	  /* Resource name quark 		*/
    XrmQuark	xrm_class;	  /* Resource class quark 		*/
    XrmQuark	xrm_type;	  /* Resource representation type quark */
    Cardinal	xrm_size;	  /* Size in bytes of representation	*/
    long int	xrm_offset;	  /* -offset-1				*/
    XrmQuark	xrm_default_type; /* Default representation type quark 	*/
    caddr_t	xrm_default_addr; /* Default resource address		*/
} XrmResource, *XrmResourceList;

#ifdef __cplusplus
extern "C" {
#endif

extern void XtCopyFromParent();

extern void XtCopyDefaultDepth();

extern void XtCopyDefaultColormap();

extern void XtCopyAncestorSensitive();

extern void XtCopyScreen();

typedef struct _XtResource *XtResourceList;

extern void XrmCompileResourceList _PROTO((XtResourceList,Cardinal));
    /* XtResourceList resources; */
    /* Cardinal     num_resources; */


extern void XtGetSubresources _PROTO((Widget,caddr_t,String,String,XtResourceList,Cardinal,ArgList,Cardinal));
    /* Widget           widget;         */
    /* caddr_t          base;           */
    /* String           name;           */
    /* String           class;          */
    /* XtResourceList   resources;      */
    /* Cardinal         num_resources;  */
    /* ArgList          args;           */
    /* Cardinal         num_args;       */

extern void XtSetValues _PROTO((Widget,ArgList,Cardinal));
    /* Widget           widget;         */
    /* ArgList          args;           */
    /* Cardinal         num_args;       */

extern void XtGetValues _PROTO((Widget,ArgList,Cardinal));
    /* Widget           widget;         */
    /* ArgList          args;           */
    /* Cardinal         num_args;       */

extern void XtSetSubvalues _PROTO((caddr_t,XtResourceList,Cardinal,ArgList,Cardinal));
    /* caddr_t          base;           */
    /* XtResourceList   resources;      */
    /* Cardinal         num_resources;  */
    /* ArgList          args;           */
    /* Cardinal         num_args;       */

extern void XtGetSubvalues _PROTO((caddr_t,XtResourceList,Cardinal,ArgList,Cardinal));
    /* caddr_t          base;           */
    /* XtResourceList   resources;      */
    /* Cardinal         num_resources;  */
    /* ArgList          args;           */
    /* Cardinal         num_args;       */

extern void XtGetResourceList _PROTO((WidgetClass,XtResourceList*,Cardinal*));
    /* WidgetClass	widget_class;		*/
    /* XtResourceList	*resources_return;	*/
    /* Cardinal		*num_resources_return;	*/

#ifdef __cplusplus
 }
#endif


typedef struct _XtResource {
    String     resource_name;   /* Resource name                            */
    String     resource_class;  /* Resource class                           */
    String     resource_type;   /* Representation type desired              */
    Cardinal    resource_size;  /* Size in bytes of representation          */
    Cardinal    resource_offset;/* Offset from base to put resource value   */
    String     default_type;    /* representation type of specified default */
    caddr_t     default_addr;   /* Address of default resource              */
} XtResource;

#define XtDefaultForeground	"XtDefaultForeground"
#define XtDefaultBackground	"XtDefaultBackground"
#define XtDefaultFont		"XtDefaultFont"

/*
 * If we're going to go sticking proc *'s into default_addr, we should use a
 * different type for the field. Possibly XtArgVal?
 */

#define XtOffset(type,field) \
        ((unsigned int) (((char *) (&(((type)NULL)->field))) - \
                         ((char *) NULL)))

#ifdef notdef
/* this doesn't work on picky compilers */
#define XtOffset(type,field)    ((unsigned int)&(((type)NULL)->field))
#endif

/*************************************************************
 *
 * Error Handling
 *
 ************************************************************/

#ifdef __cplusplus
extern "C" {
#endif
typedef void (*XtErrorMsgHandler) _PROTO((String,String,String,String,String*,Cardinal*));
/*  String name,type,class,defaultp;
    String* params;
    Cardinal* num_params;
*/


extern void XtAppSetErrorMsgHandler _PROTO((XtAppContext,XtErrorMsgHandler));
    /* XtAppContext	   app;		*/
    /* XtErrorMsgHandler   handler;    */

extern void XtSetErrorMsgHandler _PROTO((XtErrorMsgHandler));
    /* XtErrorMsgHandler   handler;    */

extern void XtAppSetWarningMsgHandler _PROTO((XtAppContext,XtErrorMsgHandler));
    /* XtAppContext	   app;		*/
    /* XtErrorMsgHandler   handler;    */

extern void XtSetWarningMsgHandler _PROTO((XtErrorMsgHandler));
    /* XtErrorMsgHandler   handler;    */

extern void XtAppErrorMsg _PROTO((XtAppContext,String,String,String,String,String*,Cardinal*));
    /* XtAppContext	   app;		*/
/*  String name,type,class,defaultp;
    String* params;
    Cardinal* num_params;
*/

extern void XtErrorMsg _PROTO((String,String,String,String,String*,Cardinal*));
/*  String name,type,class,defaultp;
    String* params;
    Cardinal* num_params;
*/

extern void XtAppWarningMsg _PROTO((XtAppContext,String,String,String,String,String*,Cardinal*));
    /* XtAppContext	   app;		*/
/*  String name,type,class,defaultp;
    String* params;
    Cardinal* num_params;
*/

extern void XtWarningMsg _PROTO((String,String,String,String,String*,Cardinal*));
/*  String name,type,class,defaultp;
    String* params;
    Cardinal* num_params;
*/

typedef void (*XtErrorHandler) _PROTO((String));
/*  String msg;
*/

extern void XtAppSetErrorHandler _PROTO((XtAppContext,XtErrorHandler));
    /* XtAppContext	   app;		*/
    /* XtErrorHandler   handler;    */

extern void XtSetErrorHandler _PROTO((XtErrorHandler));
    /* XtErrorHandler   handler;    */

extern void XtAppSetWarningHandler _PROTO((XtAppContext,XtErrorHandler));
    /* XtAppContext	   app;		*/
    /* XtErrorHandler   handler;    */

extern void XtSetWarningHandler _PROTO((XtErrorHandler));
    /* XtErrorHandler   handler;    */

extern void XtAppError _PROTO((XtAppContext,String));
    /* XtAppContext	   app;		*/
/*  String message;
*/

extern void XtError _PROTO((String));
/*  String message;
*/

extern void XtAppWarning _PROTO((XtAppContext,String));
    /* XtAppContext	   app;		*/
/*  String message;
*/

extern void XtWarning _PROTO((String));
/*  String message;
*/

extern XrmDatabase *XtAppGetErrorDatabase _PROTO((XtAppContext));
    /* XtAppContext	   app;		*/

extern XrmDatabase *XtGetErrorDatabase();
/* no paramters, returns toolkit error database*/


extern void XtAppGetErrorDatabaseText _PROTO((XtAppContext,char *,char *,char *,char *,char *,int,XrmDatabase));
    /* XtAppContext	   app;		*/
/*  char *name, *type,*class;
    char *defaultp;
    char *buffer;
    int nbytes;
    XrmDatabase database;
*/

extern void XtGetErrorDatabaseText _PROTO((char *,char *,char *,char *,char *,int));
/*  char *name, *type,*class;
    char *defaultp;
    char *buffer;
    int nbytes;
*/

#ifdef __cplusplus
 }
#endif


/****************************************************************
 *
 * Memory Management
 *
 ****************************************************************/

#define XtNew(type) ((type *) XtMalloc((unsigned) sizeof(type)))
#define XtNewString(str) (strcpy(XtMalloc((unsigned) strlen(str) + 1), str))

#ifdef __cplusplus
extern "C" {
#endif


extern char *XtMalloc _PROTO((Cardinal)); /* size */
    /* Cardinal size; */

extern char *XtCalloc _PROTO((Cardinal,Cardinal)); /* num, size */
    /* Cardinal num, size; */

extern char *XtRealloc _PROTO((char*,Cardinal)); /* ptr, num */
    /* char     *ptr; */
    /* Cardinal num; */

extern void XtFree _PROTO((void*)); /* ptr */
        /* char  *ptr */

#ifdef __cplusplus
 }
#endif

/*************************************************************
 *
 *  Work procs
 *
 **************************************************************/

typedef Boolean (*XtWorkProc) _PROTO((caddr_t));
    /* caddr_t closure;  data the application registered */
    /* returns whether to remove this work procedure or not */

#ifdef __cplusplus
extern "C" {
#endif

extern XtWorkProcId XtAddWorkProc _PROTO((XtWorkProc,caddr_t));
    /*  XtWorkProc proc; */
    /*  caddr_t closure; */

extern XtWorkProcId XtAppAddWorkProc _PROTO((XtAppContext,XtWorkProc,caddr_t));
    /*  XtAppContext app; */
    /*  XtWorkProc proc; */
    /*  caddr_t closure; */

extern void  XtRemoveWorkProc _PROTO((XtWorkProcId));
    /*  XtWorkProcId id; */

#ifdef __cplusplus
 }
#endif

/****************************************************************
 *
 * Graphic Context Management
 *****************************************************************/

#ifdef __cplusplus
extern "C" {
#endif


extern GC XtGetGC _PROTO((Widget,XtGCMask,XGCValues*)); /* widget, valueMask, values */
    /* Widget    widget */
    /* XtGCMask valueMask; */
    /* XGCValues *values; */

extern void XtDestroyGC _PROTO((GC)); /* widget, gc */
    /* Widget widget; */
    /* GC gc; */

#ifdef __cplusplus
 }
#endif


/* we pass in the widget because XFreeGC needs a display, and there isn't */
/* one stored in the GC record. */
#undef _PROTO

#endif /* _XtIntrinsic_h */
/* DON'T ADD STUFF AFTER THIS #endif */
